--Ping
local g,ball,ptimer,paddle1,paddle2,ww,wh,pause,gamemode2


function love.load()
	gamemode2 = false --whether the advanced bouncing physics on the paddles are enabled or not
	pause = false
	ptimer = 0
	ww = love.window.getWidth()
	wh = love.window.getHeight()
	g = love.graphics
	--set title of window
	love.window.setTitle("Ping")
	--customize object variables
	ball = {
		score = 0,
		color = {
			255,
			255,
			255;
		},
		x = 400,
		y = 300,
		size = 10,
		dir = -1,
		xspeed = 200;
		speed = 120;
	}
	paddle1 = {
		offset = 30,
		color = {
			255,
			255,
			255;
		},
		w = 20,
		h = 100,
		y = 200,
		dir = 0,
		thinkspeed = 0.13,
		speed = 150;
	}
	paddle2 = {
		offset = 30,
		color = {
			255,
			255,
			255;
		},
		w = 20,
		h = 100,
		y = 200,
		dir = 0,
		thinkspeed = 0.13,
		speed = 150;
	}
end

function love.update(dt)
	if(not pause)then
		--update the paddle reaction timer
		ptimer = ptimer + dt
		
		--update ball's direction, check for miss
		if(ball.dir == -1)then
			if(ball.x <= paddle1.offset + paddle1.w)then
				paddle1.dir = 0
				if(ball.y + ball.size >= paddle1.y and ball.y <= paddle1.y + paddle1.h)then
					ball.dir = 1
					if(gamemode2)then
						ball.speed = math.abs(ball.y - (paddle1.y + (paddle1.h / 2))) ^ 1.6
					end
				else
					ball.score = ball.score + 1
					reset()
				end
			end
		else
			if(ball.x >= ww - paddle2.offset - paddle2.w - ball.size)then
				paddle2.dir = 0
				if(ball.y + ball.size >= paddle2.y and ball.y <= paddle2.y + paddle2.h)then
					ball.dir = -1
					if(gamemode2)then
						ball.speed = math.abs(ball.y - (paddle2.y + (paddle2.h / 2))) ^ 1.6
					end
				else
					ball.score = ball.score + 1
					reset()
				end
			end
		end
		
		--update ball's x movement
		if(ball.dir == -1)then
			ball.x = ball.x - (ball.xspeed * dt)
		elseif(ball.dir == 1)then
			ball.x = ball.x + (ball.xspeed * dt)
		end
		
		--move ball accordingly to keypresses
		if(love.keyboard.isDown("up"))then
			--collision
			if(ball.y > 2)then
				ball.y = ball.y - (ball.speed * dt)
			end
		end
		if(love.keyboard.isDown("down"))then
			--collision
			if(ball.y < 599-ball.size)then
				ball.y = ball.y + (ball.speed * dt)
			end
		end
		
		--change direction of paddles
		if(ball.dir == -1)then
			if(ptimer > paddle1.thinkspeed)then
				ptimer = 0
				if(paddleLoc(paddle1, ball) == 1)then
					paddle1.dir = 1 --move paddle up
				elseif(paddleLoc(paddle1, ball) == 0)then
					paddle1.dir = 2 --move paddle down
				elseif(paddleLoc(paddle1, ball) == 2)then
					paddle1.dir = 0 --don't move paddle
				end
			end
		elseif(ball.dir == 1)then
			if(ptimer > paddle2.thinkspeed)then
				ptimer = 0
				if(paddleLoc(paddle2, ball) == 1)then
					paddle2.dir = 1 --move paddle up
				elseif(paddleLoc(paddle2, ball) == 0)then
					paddle2.dir = 2 --move paddle down
				elseif(paddleLoc(paddle2, ball) == 2)then
					paddle2.dir = 0 --don't move paddle
				end
			end
		end
		
		--update paddle location
		if(paddle1.dir == 1)then
			paddle1.y = paddle1.y - (paddle1.speed * dt) --move paddle down
		end
		
		if(paddle1.dir == 2)then
			paddle1.y = paddle1.y + (paddle1.speed * dt) --move paddle down
		end
		
		if(paddle2.dir == 1)then
			paddle2.y = paddle2.y - (paddle2.speed * dt)
		end
		
		if(paddle2.dir == 2)then
			paddle2.y = paddle2.y + (paddle2.speed * dt)
		end
	end
end

function love.draw()
	--debug
	--g.print("1: "..paddleLoc(paddle1, ball)..", "..paddle1.dir, 10, 10)
	--g.print("2: "..paddleLoc(paddle2, ball)..", "..paddle2.dir, 10, 25)
	
	--print score
	g.printf(ball.score, 0, 0, 800, "center")

	--drawing the ball
	g.setColor(ball.color)
	g.rectangle("fill", ball.x, ball.y, ball.size, ball.size)
	g.setColor(255,255,255)
	
	--drawing the paddles
	g.setColor(paddle1.color)
	g.rectangle("fill", paddle1.offset, paddle1.y, paddle1.w, paddle1.h)
	g.setColor(paddle2.color)
	g.rectangle("fill", ww - paddle2.offset - paddle2.w, paddle2.y, paddle2.w, paddle2.h)
	g.setColor(255,255,255)
end

--quit on escape
function love.keypressed(k)
	if(k=="escape")then
		love.event.push("quit");
	end
end

function paddleLoc(paddle, ball)
	if(ball.y >= paddle.y and ball.y <= paddle.y + paddle.h)then
		return 2 --paddle is even with the ball
	elseif(ball.y <= paddle.y)then
		return 1 --paddle is under the ball
	elseif(ball.y >= paddle.y + paddle.h)then
		return 0 --paddle is over the ball
	end
end

function reset()
	ball.x = 400
	ball.y = 300
	ball.speed = 100
	paddle1.y = 200
	paddle2.y = 200
	ball.dir = -ball.dir
end
